<template>
  <div id="show_wallet" class="createPost-container">
    <el-row style="margin-bottom: 20px;padding-bottom: 20px;">
      <el-col :span="2" class="line">
        {{ $t('row.title') }}:
      </el-col>
      <el-col :span="4">
        {{ Wallet.title }}
      </el-col>
      <el-col :span="1">
        &nbsp;
      </el-col>
      <el-col :span="2" class="line">
        {{ $t('row.address') }}:
      </el-col>
      <el-col :span="4">
        {{ Wallet.address }}
      </el-col>
      <el-col :span="1">
        &nbsp;
      </el-col>
      <el-col :span="2" class="line">
        {{ $t('form.explain') }}:
      </el-col>
      <el-col :span="7">
        {{ Wallet.explain }}
      </el-col>
    </el-row>
    <el-row style="margin-bottom: 20px;padding-bottom: 20px;">
      <el-col :span="2" class="line">
        {{ $t('row.userAccount') }}:
      </el-col>
      <el-col :span="4">
        {{ user_account }}
      </el-col>
      <el-col :span="1">
        &nbsp;
      </el-col>
      <el-col :span="2" class="line">
        {{ $t('row.networkAccount') }}:
      </el-col>
      <el-col :span="4">
        {{ network_account }}
      </el-col>
    </el-row>
    <el-form ref="chargeUserAccountForm" :model="chargeUserAccountForm" class="form-container" style="width: 100%;margin-top: 20px;padding-top: 20px;border-top: 1px solid #eee">
      <el-row>
        <el-col :span="6" class="line" style="line-height: 35px">
          {{ $t('form.chargeUserAccount') }}
        </el-col>
        <el-col :span="7">
          <el-form-item>
            <el-input v-model="chargeUserAccountForm.price" type="text" :placeholder="$t('form.amount')" required />
            <el-input v-model="chargeUserAccountForm.wallet_id" type="hidden" required />
          </el-form-item>
        </el-col>
        <el-col :span="1">
          &nbsp;
        </el-col>
        <el-col :span="1">
          <el-form-item>
            <el-button type="primary" @click="submitChargeUserAccountForm">
              {{ $t('form.submit') }}
            </el-button>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <el-form ref="changeUserAccountToNetworkAccountForm" :model="changeUserAccountToNetworkAccountForm" class="form-container" style="width: 100%;margin-top: 20px;padding-top: 20px;border-top: 1px solid #eee">
      <el-row>
        <el-col :span="6" class="line" style="line-height: 35px">
          {{ $t('form.changeUserAccountToNetworkAccount') }}
        </el-col>
        <el-col :span="7">
          <el-form-item>
            <el-input v-model="changeUserAccountToNetworkAccountForm.price" type="text" :placeholder="$t('form.amount')" required />
            <el-input v-model="changeUserAccountToNetworkAccountForm.wallet_id" type="hidden" required />
          </el-form-item>
        </el-col>
        <el-col :span="1">
          &nbsp;
        </el-col>
        <el-col :span="1">
          <el-form-item>
            <el-button type="primary" @click="submitChangeUserAccountToNetworkAccount">
              {{ $t('form.submit') }}
            </el-button>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <el-form ref="changeNetworkAccountToUserAccountForm" :model="changeNetworkAccountToUserAccountForm" class="form-container" style="width: 100%;margin-top: 20px;padding-top: 20px;border-top: 1px solid #eee">
      <el-row>
        <el-col :span="6" class="line" style="line-height: 35px">
          {{ $t('form.changeNetworkAccountToUserAccount') }}
        </el-col>
        <el-col :span="7">
          <el-form-item>
            <el-input v-model="changeNetworkAccountToUserAccountForm.price" type="text" :placeholder="$t('form.amount')" required />
            <el-input v-model="changeNetworkAccountToUserAccountForm.wallet_id" type="hidden" required />
          </el-form-item>
        </el-col>
        <el-col :span="1">
          &nbsp;
        </el-col>
        <el-col :span="1">
          <el-form-item>
            <el-button type="primary" @click="submitChangeNetworkAccountToUserAccount">
              {{ $t('form.submit') }}
            </el-button>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
  </div>
</template>

<script>
import Wallet from '@/api/task';
const walletResource = new Wallet('wallets');

export default {
  name: 'WalletShow',
  components: { },
  filters: {
    statusFilter(status) {
      const statusMap = {
        published: 'success',
        draft: 'info',
        deleted: 'danger',
      };
      return statusMap[status];
    },
  },
  data() {
    const validateRequire = (rule, value, callback) => {
      if (value === '') {
        this.$message({
          message: rule.field + ' is required',
          type: 'error',
        });
        callback(new Error(rule.field + ' is required'));
      } else {
        callback();
      }
    };
    return {
      loading: true,
      postForm: {
        amount: '',
        token_id: '',
        wallet_id: '',
      },
      chargeUserAccountForm: {
        price: '',
        wallet_id: '',
      },
      changeUserAccountToNetworkAccountForm: {
        price: '',
        wallet_id: '',
      },
      changeNetworkAccountToUserAccountForm: {
        price: '',
        wallet_id: '',
      },
      rules: {
        token_id: [{ validator: validateRequire }],
        amount: [{ validator: validateRequire }],
      },
      user_account: '',
      network_account: '',
      Tokens: [],
      Tokens_Wallets: [],
      Wallet: [],
    };
  },
  created() {
    const id = this.$route.params && this.$route.params.id;
    this.fetchData(id);
  },
  methods: {
    transmitToken(id) {},
    removeToken(id) {
      alert(id);
    },
    fetchData(id) {
      walletResource.show(id)
        .then(response => {
          this.Tokens = response.Token;
          this.Wallet = response.Wallet;
          this.user_account = this.Wallet.user_account;
          this.network_account = this.Wallet.network_account;
          this.postForm.wallet_id = response.Wallet.id;
          this.chargeUserAccountForm.wallet_id = response.Wallet.id;
          this.changeUserAccountToNetworkAccountForm.wallet_id = response.Wallet.id;
          this.changeNetworkAccountToUserAccountForm.wallet_id = response.Wallet.id;
          this.loading = true;
          this.fetchTokens(response.Wallet.id);
        })
        .catch(err => {
          console.log(err);
        });
    },
    fetchTokens(id) {
      walletResource.fetchTokens(id)
        .then(response => {
          this.Tokens_Wallets = response.tokens;
          this.loading = false;
        })
        .catch(err => {
          console.log(err);
        });
    },
    submitForm() {
      console.log(this.postForm);
      this.$refs.postForm.validate(valid => {
        if (valid) {
          this.loading = true;
          walletResource
            .addToken(this.postForm)
            .then(response => {
              this.fetchTokens(this.postForm.wallet_id);
              this.$message({
                message: 'Token has been added successfully.',
                type: 'success',
                duration: 5 * 1000,
              });
            })
            .catch(error => {
              console.log(error);
            })
            .finally(() => {
              this.userCreating = false;
            });
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
    submitChargeUserAccountForm() {
      this.$refs.chargeUserAccountForm.validate(valid => {
        if (valid) {
          this.loading = true;
          walletResource
            .submitChargeUserAccountForm(this.chargeUserAccountForm)
            .then(response => {
              this.user_account = response.user_account;
              this.network_account = response.network_account;
              this.$message({
                message: 'User Account has been charged successfully.',
                type: 'success',
                duration: 5 * 1000,
              });
            })
            .catch(error => {
              console.log(error);
            })
            .finally(() => {
              this.userCreating = false;
            });
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
    submitChangeUserAccountToNetworkAccount() {
      this.$refs.changeUserAccountToNetworkAccountForm.validate(valid => {
        if (valid) {
          this.loading = true;
          walletResource
            .submitChangeUserAccountToNetworkAccount(this.changeUserAccountToNetworkAccountForm)
            .then(response => {
              this.network_account = response.network_account;
              this.user_account = response.user_account;
              this.$message({
                message: 'Network Account has been charged successfully.',
                type: 'success',
                duration: 5 * 1000,
              });
            })
            .catch(error => {
              console.log(error);
            })
            .finally(() => {
              this.userCreating = false;
            });
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
    submitChangeNetworkAccountToUserAccount() {
      this.$refs.changeNetworkAccountToUserAccountForm.validate(valid => {
        if (valid) {
          this.loading = true;
          walletResource
            .submitChangeNetworkAccountToUserAccount(this.changeNetworkAccountToUserAccountForm)
            .then(response => {
              this.network_account = response.network_account;
              this.user_account = response.user_account;
              this.$message({
                message: 'Network Account has been charged successfully.',
                type: 'success',
                duration: 5 * 1000,
              });
            })
            .catch(error => {
              console.log(error);
            })
            .finally(() => {
              this.userCreating = false;
            });
        } else {
          console.log('error submit!!');
          return false;
        }
      });
    },
  },
};
</script>

<style scoped>
.edit-input {
  padding-right: 100px;
}
.cancel-btn {
  position: absolute;
  right: 15px;
  top: 10px;
}
</style>
